Xapian: API Documentation: Xapian::LatLongDistancePostingSource Class Reference

xapian-core 2.0.0

Public Member Functions | List of all members
Xapian::LatLongDistancePostingSource Class Reference

Posting source which returns a weight based on geospatial distance. More...

`#include <geospatial.h>`

Inheritance diagram for Xapian::LatLongDistancePostingSource:
[legend]

## Public Member Functions
| LatLongDistancePostingSource (Xapian::valueno slot_, const LatLongCoords &centre_, const LatLongMetric &metric_, double max_range_=0.0, double k1_=1000.0, double k2_=1.0)
| Construct a new posting source which returns only documents within range of one of the central coordinates.
| LatLongDistancePostingSource (Xapian::valueno slot_, const LatLongCoords &centre_, double max_range_=0.0, double k1_=1000.0, double k2_=1.0)
| Construct a new posting source which returns only documents within range of one of the central coordinates.
void | next (double min_wt)
| Advance the current position to the next matching document.
void | skip_to (Xapian::docid min_docid, double min_wt)
| Advance to the specified docid.
bool | check (Xapian::docid min_docid, double min_wt)
| Check if the specified docid occurs.
double | get_weight () const
| Return the weight contribution for the current document.
LatLongDistancePostingSource * | clone () const
| Clone the posting source.
std::string | name () const
| Name of the posting source class.
std::string | serialise () const
| Serialise object parameters into a string.
LatLongDistancePostingSource * | unserialise_with_registry (const std::string &serialised, const Registry &registry) const
| Create object given string serialisation returned by serialise().
void | reset (const Database &db_, Xapian::doccount shard_index)
| Set this PostingSource to the start of the list of postings.
std::string | get_description () const
| Return a string describing this object.
Public Member Functions inherited from Xapian::ValuePostingSource
| ValuePostingSource (Xapian::valueno slot_) noexcept
| Construct a ValuePostingSource.
Xapian::doccount | get_termfreq_min () const
| A lower bound on the number of documents this object can return.
Xapian::doccount | get_termfreq_est () const
| An estimate of the number of documents this object can return.
Xapian::doccount | get_termfreq_max () const
| An upper bound on the number of documents this object can return.
void | next (double min_wt)
| Advance the current position to the next matching document.
void | skip_to (Xapian::docid min_docid, double min_wt)
| Advance to the specified docid.
bool | check (Xapian::docid min_docid, double min_wt)
| Check if the specified docid occurs.
bool | at_end () const
| Return true if the current position is past the last entry in this list.
Xapian::docid | get_docid () const
| Return the current docid.
void | reset (const Database &db_, Xapian::doccount shard_index)
| Set this PostingSource to the start of the list of postings.
Xapian::Database | get_database () const
| The database we're reading values from.
Xapian::valueno | get_slot () const
| The slot we're reading values from.
std::string | get_value () const
| Read current value.
void | done ()
| End the iteration.
bool | get_started () const
| Flag indicating if we've started (true if we have).
void | set_termfreq_min (Xapian::doccount termfreq_min_)
| Set a lower bound on the term frequency.
void | set_termfreq_est (Xapian::doccount termfreq_est_)
| An estimate of the term frequency.
void | set_termfreq_max (Xapian::doccount termfreq_max_)
| An upper bound on the term frequency.
std::string | get_description () const
| Return a string describing this object.
Public Member Functions inherited from Xapian::PostingSource
| PostingSource () noexcept
| Allow subclasses to be instantiated.
void | set_maxweight (double max_weight)
| Specify an upper bound on what get_weight() will return from now on.
double | get_maxweight () const noexcept
| Return the currently set upper bound on what get_weight() can return.
virtual PostingSource * | unserialise (const std::string &serialised) const
| Create object given string serialisation returned by serialise().
virtual void | init (const Database &db)
| Older method which did the same job as reset().
PostingSource * | release ()
| Start reference counting this object.
const PostingSource * | release () const
| Start reference counting this object.

## Detailed Description

Posting source which returns a weight based on geospatial distance.

Experimental - see https://xapian.org/docs/deprecation#experimental-features

Results are weighted by the distance from a fixed point, or list of points, calculated according to the metric supplied. If multiple points are supplied (either in the constructor, or in the coordinates stored in a document), the closest pointwise distance is used.

Documents further away than a specified maximum range (or with no location stored in the specified slot) will not be returned.

The weight returned is computed from the distance using the formula:

k1 * pow(distance + k1, -k2)

(Where k1 and k2 are (strictly) positive, floating point constants, which default to 1000 and 1, respectively. Distance is measured in metres, so this means that something at the centre gets a weight of 1.0, something 1km away gets a weight of 0.5, and something 3km away gets a weight of 0.25, etc)

## Constructor & Destructor Documentation

## ◆ LatLongDistancePostingSource() [1/2]

Xapian::LatLongDistancePostingSource::LatLongDistancePostingSource | ( | Xapian::valueno | slot_,
|  | const LatLongCoords & | centre_,
|  | const LatLongMetric & | metric_,
|  | double | max_range_ = 0.0,
|  | double | k1_ = 1000.0,
|  | double | k2_ = 1.0 )

Construct a new posting source which returns only documents within range of one of the central coordinates.

Parameters

  slot_ | The value slot to read values from.
  centre_ | The centre point to use for distance calculations.
  metric_ | The metric to use for distance calculations.
  max_range_ | The maximum distance for documents which are returned.
  k1_ | The k1 constant to use in the weighting function.
  k2_ | The k2 constant to use in the weighting function.

## ◆ LatLongDistancePostingSource() [2/2]

Xapian::LatLongDistancePostingSource::LatLongDistancePostingSource | ( | Xapian::valueno | slot_,
|  | const LatLongCoords & | centre_,
|  | double | max_range_ = 0.0,
|  | double | k1_ = 1000.0,
|  | double | k2_ = 1.0 )

Construct a new posting source which returns only documents within range of one of the central coordinates.

Parameters

  slot_ | The value slot to read values from.
  centre_ | The centre point to use for distance calculations.
  max_range_ | The maximum distance for documents which are returned.
  k1_ | The k1 constant to use in the weighting function.
  k2_ | The k2 constant to use in the weighting function.

Xapian::GreatCircleMetric is used as the metric.

## Member Function Documentation

## ◆ check()

bool Xapian::LatLongDistancePostingSource::check | ( | Xapian::docid | did,
|  | double | min_wt )
| virtual

Check if the specified docid occurs.

The caller is required to ensure that the specified document id did actually exists in the database. If it does, it must move to that document id, and return true. If it does not, it may either:

- return true, having moved to a definite position (including "at_end"), which must be the same position as skip_to() would have moved to.

or

- return false, having moved to an "indeterminate" position, such that a subsequent call to next() or skip_to() will move to the next matching position after did.

Generally, this method should act like skip_to() and return true if that can be done at little extra cost.

Otherwise it should simply check if a particular docid is present, returning true if it is, and false if it isn't.

The default implementation calls skip_to() and always returns true.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the reset() method for details.

Parameters

  did | The document id to check.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

## ◆ clone()

LatLongDistancePostingSource * Xapian::LatLongDistancePostingSource::clone | ( |  | ) | const
| virtual

Clone the posting source.

The clone should inherit the configuration of the parent, but need not inherit the state. ie, the clone does not need to be in the same iteration position as the original: the matcher will always call reset() on the clone before attempting to move the iterator, or read the information about the current position of the iterator.

This may return NULL to indicate that cloning is not supported. In this case, the PostingSource may only be used with a single-database search.

The default implementation returns NULL.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Reimplemented from Xapian::PostingSource.

## ◆ get_description()

std::string Xapian::LatLongDistancePostingSource::get_description | ( |  | ) | const
| virtual

Return a string describing this object.

This default implementation returns a generic answer. This default it provided to avoid forcing those deriving their own PostingSource subclass from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented from Xapian::PostingSource.

## ◆ get_weight()

double Xapian::LatLongDistancePostingSource::get_weight | ( |  | ) | const
| virtual

Return the weight contribution for the current document.

This default implementation always returns 0, for convenience when implementing "weight-less" PostingSource subclasses.

This method may assume that it will only be called when there is a "current document". In detail: Xapian will always call reset() on a PostingSource before calling this for the first time. It will also only call this if the PostingSource reports that it is pointing to a valid document (ie, it will not call it before calling at least one of next(), skip_to() or check(), and will ensure that the PostingSource is not at the end by calling at_end()).

Reimplemented from Xapian::PostingSource.

## ◆ name()

std::string Xapian::LatLongDistancePostingSource::name | ( |  | ) | const
| virtual

Name of the posting source class.

This is used when serialising and unserialising posting sources; for example, for performing remote searches.

If the subclass is in a C++ namespace, the namespace should be included in the name, using "::" as a separator. For example, for a PostingSource subclass called "FooPostingSource" in the "Xapian" namespace the result of this call should be "Xapian::FooPostingSource".

This should only be implemented if serialise() and unserialise() are also implemented. The default implementation returns an empty string.

If this returns an empty string, Xapian will assume that serialise() and unserialise() are not implemented.

Reimplemented from Xapian::PostingSource.

## ◆ next()

void Xapian::LatLongDistancePostingSource::next | ( | double | min_wt | ) |
| virtual

Advance the current position to the next matching document.

The PostingSource starts before the first entry in the list, so next(), skip_to() or check() must be called before any methods which need the context of the current position.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Parameters

  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Implements Xapian::PostingSource.

## ◆ reset()

void Xapian::LatLongDistancePostingSource::reset | ( | const Database & | db,
|  | Xapian::doccount | shard_index )
| virtual

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, reset() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters

  db | The database which the PostingSource should iterate through.
  shard_index | The 0-based index indicating which shard in a multi-database db is. This can be useful if you have an external source of postings corresponding to each shard.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

A default implementation is provided which calls the older init() method to allow existing subclasses to continue to work, but the default implementation of init() throws Xapian::InvalidOperationError so you must override either this method or init(). In new code, override this method in preference.

Since
  Added in Xapian 2.0.0.

Reimplemented from Xapian::PostingSource.

## ◆ serialise()

std::string Xapian::LatLongDistancePostingSource::serialise | ( |  | ) | const
| virtual

Serialise object parameters into a string.

The serialised parameters should represent the configuration of the posting source, but need not (indeed, should not) represent the current iteration state.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::PostingSource.

## ◆ skip_to()

void Xapian::LatLongDistancePostingSource::skip_to | ( | Xapian::docid | did,
|  | double | min_wt )
| virtual

Advance to the specified docid.

If the specified docid isn't in the list, position ourselves on the first document after it (or at_end() if no greater docids are present).

If the current position is already the specified docid, this method will leave the position unmodified.

If the specified docid is earlier than the current position, the behaviour is unspecified. A sensible behaviour would be to leave the current position unmodified, but it is also reasonable to move to the specified docid.

The default implementation calls next() repeatedly, which works but skip_to() can often be implemented much more efficiently.

Xapian will always call reset() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the reset() method for details.

Parameters

  did | The document id to advance to.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

## ◆ unserialise_with_registry()

LatLongDistancePostingSource * Xapian::LatLongDistancePostingSource::unserialise_with_registry | ( | const std::string & | serialised,
|  | const Registry & | registry ) const
| virtual

Create object given string serialisation returned by serialise().

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

This method is supplied with a Registry object, which can be used when unserialising objects contained within the posting source. The default implementation simply calls unserialise() which doesn't take the Registry object, so you do not need to implement this method unless you want to take advantage of the Registry object when unserialising.

Parameters

  serialised | A serialised instance of this PostingSource subclass.
  registry | The Xapian::Registry object to use.

Reimplemented from Xapian::PostingSource.

The documentation for this class was generated from the following file:

- xapian/geospatial.h